/*Data Access Library. v. 1.1.
 *Thread action executor interface. 
 *AUTHOR:  Alexander Jaremenko <jarem@altavista.net>
 *RELEASE DATE: 
 */

package JProjects.eab.data;

/**This interface used internally to realize asynchronous data access on background
 *thread. Known implementors are DatastoreJDBC, DAManager, subclasses of PersistentObject generated by Data Acess Builder.
 *@author Alexander Jaremenko  <address><a href="mailto:jarem@altavista.net">&lt jarem@altavista.net &gt</a></address>
*/
interface OnThreadActionExecutor  {

    public abstract void _executeAction(String action,Object[] params) throws Exception;
    public abstract void _handleException(Exception ex);
}
